//attention: this function modify the data from matlab in-place. It's very danger.

#include "mex.h"
#include "matrix.h"
#include "mat.h"
#include <queue>
#include <functional>
#include <vector>
#include <iostream>
#include <fstream>
#include <chrono>
//#include <boost/format.hpp>
#include <tbb/parallel_for.h>
#include <omp.h>
#include <tbb/parallel_invoke.h>
//#include <boost/lexical_cast.hpp>
#include <tbb/parallel_reduce.h>
#include <tuple>
#include <cassert>
//#define my_debug
#define mynum   2
int num_image = 1;
// MATFile *pmat;
struct mystruct {
	float u, u_for_openmp, * data, ricci;
	mxUint8 bw;
};
struct read {
	int total, * offset;
	mystruct* base;
	mxArray* p0;
	float mu;
	float lambda1;
	float lambda2;
	float c1;
	float c2;
	bool record;

	int times;

};
void getneighbor(const mxArray* mm, int& total, int*& offset) {
	auto aa = mxGetDimensions(mm);
	int dims = mxGetNumberOfDimensions(mm);
	offset = new int[2 * dims];
	int t1 = 1;
	for (int i = 0, j = 0; i < 2 * dims; i += 2, j++) {
		offset[i] = t1;
		offset[i + 1] = -t1;
		t1 *= aa[j];
	}
	total = t1;

}
class MyClass
{
public:
	MyClass(read& temp, mxArray* plhs[]);
	~MyClass();



	void faster_distance_transform_iterate3(int* q1, int* q2, int* band, int& size_band, int& size1, int& size2) {
		float d1 = 0;
		int ddims = dims * 2, i1, i2; size1 = 0, size2 = 0;
		auto breadth_search = [this, &band, &size_band](int* invec, int& innum, int* outvec, int& outnum) {
			outnum = 0;
			int ddims = dims * 2, i1, i2;
			float d1, d2;
			int* p_invec = invec, * p_outvec = outvec, * p_band = band + size_band;
			mystruct* p_base;
			for (int i = 0; i < innum; i++, p_invec++) {
				i1 = *p_invec;
				for (int j = 0; j < ddims; j++) {
					int tid = i1 + offset[j];
					p_base = base + tid;
					mxUint8& mm = p_base->bw;
					float& dd = p_base->u;
					d1 = base[i1].u + 1;
					if (d1 < dd) {
						if (mm == 1) {
							dd = d1;
							*(p_outvec++) = tid;
							outnum++;
							*(p_band++) = tid;
							size_band++;
							mm = 2;
							continue;
						}
						if (mm == 2) {
							dd = d1;
						}
					}
				}
			}
			};
		breadth_search(boundary, size_boundary, q1, size1);
		breadth_search(q1, size1, q2, size2);


	}
	void faster_distance_transform_inverse_iterate3(int* q1, int* q2, int* band, int& size_band, int& size1, int& size2) {
		float d1 = 0;
		int ddims = dims * 2, i1, i2; size1 = 0, size2 = 0;
		auto breadth_search = [this, &band, &size_band](int* invec, int& innum, int* outvec, int& outnum) {
			outnum = 0;
			int ddims = dims * 2, i1, i2;
			float d1, d2;
			int* p_invec = invec, * p_outvec = outvec, * p_band = band + size_band;
			mystruct* p_base;
			for (int i = 0; i < innum; i++, p_invec++) {
				i1 = *p_invec;
				for (int j = 0; j < ddims; j++) {
					int tid = i1 + offset[j];
					p_base = base + tid;
					mxUint8& mm = p_base->bw;
					float& dd = p_base->u_for_openmp;
					d1 = base[i1].u_for_openmp - 1;
					if (d1 > dd) {
						if (mm == 0) {
							dd = d1;
							*(p_outvec++) = tid;
							outnum++;
							*(p_band++) = tid;
							size_band++;
							mm = 2;
							continue;
						}
						if (mm == 2) {
							dd = d1;
						}
					}
				}
			}
			};
		breadth_search(boundary, size_boundary, q1, size1);
		breadth_search(q1, size1, q2, size2);
		/*	breadth_search(q2, size2, q1, size1);*/
			/*breadth_search(q1, size1, q2, size2);
			breadth_search(q2, size2, q1, size1);*/
	}
	void normalize_abs(float* vv, int size) {
		float mmax = -1, d1, d2;
		float* pvv = vv;
		float  rmax = *pvv, rmin = *pvv;
		for (int i = 0; i < size; i++, pvv++) {
			d1 = *pvv;

			d2 = d1 < 0 ? -d1 : d1;
			mmax = d2 > mmax ? d2 : mmax;

		}
		/*if (rmax - rmin < 0.001)
			return;*/
		// the maximum of it is 0.5
		//you can change it
		mmax = 0.5 / mmax;
		pvv = vv;
		for (int i = 0; i < size; i++, pvv++) {
			*(pvv) *= mmax;
		}
	}
	void normalize_max(float* vv, int size) {
		std::for_each_n(vv, size, [](float &s) {if (s>1)s = 1; else if (s < -1) s = -1; });
	}
	void get_mean_with_new_boundary_2_1() {

		int i1;
		float* s1, * s2;
		int* n1, * n2;
		s1 = new float[num_image];
		s2 = new float[num_image];
		n1 = new int[num_image];
		n2 = new int[num_image];
		memset(s1, 0, sizeof(float) * num_image);
		memset(s2, 0, sizeof(float) * num_image);
		memset(n1, 0, sizeof(int) * num_image);
		memset(n2, 0, sizeof(int) * num_image);
		int ddims = dims * 2;
		bool boundary_flag = 1;

		size1 = 0;

		size2 = 0;

		size_boundary = 0;
		int* p_band = band;
		int* p_q1 = q1;
		int* p_q2 = q2;
		int* p_boundary = boundary;
		mystruct* p_base;
		for (int i = 0; i < size_band; i++, p_band++) {

			i1 = *p_band;
			p_base = base + i1;
			if (p_base->u < 0) {
				for (int j = 0; j < num_image; j++) {
					n2[j]++;
					s2[j] += p_base->data[j];
				}
				p_base->bw = 0;
				*(p_q2++) = i1;
				size2++;
				continue;
			}
			for (int j = 0; j < num_image; j++) {
				n1[j]++;
				s1[j] += p_base->data[j];
			}

			boundary_flag = 0;
			// pad value of u must be c2(-2);
			for (int j = 0; j < ddims; j++) {
				if (base[i1 + offset[j]].u < 0) {
					boundary_flag = 1;
					*(p_boundary++) = i1;
					size_boundary++;
					p_base->bw = 2;

					break;
				}
			}
			if (!boundary_flag) {

				p_base->bw = 1;
				*(p_q1++) = i1;
				size1++;

			}


		}
		for (int j = 0; j < num_image; j++) {
			mc1[j] = s1[j] / (n1[j] == 0 ? 1 : n1[j]);
			mc2[j] = s2[j] / (n2[j] == 0 ? 1 : n2[j]);
		}


		delete[] s1;
		delete[] s2;
		delete[] n1;
		delete[] n2;
	}

	void update_boundary_1()
	{
		int i1, i2;
		int ddims = dims * 2;
		float u1, u2, u3 = 0, u4, u5;
		// matPutVariable(pmat, "update_boundary0", p0);
		//#pragma omp simd
		{
			auto fff1 = [this, &ddims](const tbb::blocked_range<size_t>& r)
				{
					float d1;
					int i = r.begin();
					float* p_t1 = t1 + i, * p_t2 = t2 + i;
					int* p_boundary = boundary + i;
					mystruct* p_base;
					mystruct* p_base1;
					float* u4;
					float* u5; 
					u4 = new float[num_image];
					u5 = new float[num_image];
					
					for (; i != r.end(); ++i, ++p_t1, ++p_t2, ++p_boundary)
					{
						int i1 = *(p_boundary), i2;
						p_base = base + i1;
						float u3 = 0;
						float u1 = p_base->u;
						float u2 = p_base->ricci;
						for (int j = 0; j < ddims; j++)
						{
							i2 = i1 + offset[j];
							p_base1 = base + i2;
							u3 += ((u2 + p_base1->ricci) * (p_base1->u - u1) / 2);
						}
			
						for (int j = 0; j < num_image; j++) {
							d1 = p_base->data[j];
							u4[j] = (d1 - mc1[j]);
							u5[j] = (d1 - mc2[j]);
						}


						*p_t1 = u3;
						*p_t2 = 0;
						for (int j = 0; j < num_image; j++) {
							(*p_t2) += lambda1 * u4[j] * u4[j] - lambda2 * u5[j] * u5[j];
						}
					};
					delete[] u4;
					delete[] u5;
				};
			tbb::parallel_for(tbb::blocked_range<size_t>(0, size_boundary), fff1);
		}

		normalize_abs(t1, size_boundary);
		normalize_abs(t2, size_boundary);
		{
			auto fff1 = [this, &ddims](const tbb::blocked_range<size_t>& r)
				{
					int i = r.begin();
					float* p_t3 = t3 + i, * p_t2 = t2 + i, * p_t1 = t1 + i;
					for (; i != r.end(); ++i, ++p_t1, ++p_t2, ++p_t3)
					{
						*p_t3 = (mu * (*p_t1) - (*p_t2));

					};
				};
			tbb::parallel_for(tbb::blocked_range<size_t>(0, size_boundary), fff1);
		}
#ifdef my_debug
		{
			auto [min, max] = std::minmax_element(t1, t1 + size_boundary);
			printf("t1 : %.6f %.6f \n", *min, *max);
		}
		{
			auto [min, max] = std::minmax_element(t2, t2 + size_boundary);
			printf("t2 : %.6f %.6f \n", *min, *max);
		}
		{
			auto [min, max] = std::minmax_element(t3, t3 + size_boundary);
			printf("t3 : %.6f %.6f \n", *min, *max);
		}
#endif // DEBUG

		
		
		normalize_max(t3, size_boundary);
		{
			auto ff1 = [this]()
				{
					auto fff1 = [this](const tbb::blocked_range<size_t>& r)
						{
							mystruct* p_base;
							int i = r.begin();
							int* p_boundary = boundary + i; float* p_t3 = t3 + i;

							for (; i != r.end(); ++i, ++p_boundary, ++p_t3)
							{
								int& i1 = *p_boundary;
								p_base = base + i1;
								float& d1 = p_base->u;
								d1 += ((*p_t3));
								p_base->u_for_openmp = d1;

							};
						};
					tbb::parallel_for(tbb::blocked_range<size_t>(0, size_boundary), fff1);
				};
			auto ff2 = [this]()
				{
					auto fff1 = [this](const tbb::blocked_range<size_t>& r)
						{
							mystruct* p_base;
							int i = r.begin();
							int* p_q1 = q1 + i;
							for (; i != r.end(); ++i, p_q1++)
							{
								int& i1 = *p_q1;
								p_base = base + i1;
								p_base->u = c1;
								p_base->u_for_openmp = c1;

							};
						};
					tbb::parallel_for(tbb::blocked_range<size_t>(0, size1), fff1);
				};
			auto ff3 = [this]()
				{
					auto fff1 = [this](const tbb::blocked_range<size_t>& r)
						{
							mystruct* p_base;
							int i = r.begin();
							int* p_q2 = q2 + i;
							for (; i != r.end(); ++i, p_q2++)
							{
								int& i1 = *p_q2;
								p_base = base + i1;
								p_base->u = c2;
								p_base->u_for_openmp = c2;

							};
						};
					tbb::parallel_for(tbb::blocked_range<size_t>(0, size2), fff1);

				};
			tbb::parallel_invoke(ff1, ff2, ff3);
		}

		size1 = 0;

		size2 = 0;

	}
	void init_boundary() {
		int ddims = dims * 2;
		bool is_boundary = 1;
		mystruct* p_base = base;

		int* p_boundary = boundary;

		for (int i1 = 0; i1 < total; i1++, p_base++) {
			float& uu = p_base->u;
			if (uu < 0) {
				if (uu > c2)
					uu = c2;
				continue;
			}
			is_boundary = 0;

			for (int j = 0; j < ddims; j++) {
				if (base[i1 + offset[j]].u < 0) {
					is_boundary = 1;
					*(p_boundary++) = i1;
					size_boundary++;
					p_base->bw = 2;
					break;
				}
			}
			if (is_boundary)
				continue;
			if (uu < c1)
				uu = c1;
		}



	}
	void iterate3_2() {
		int i1, i2, i3;
		// matPutVariable(pmat,"iterate0" , p0);

		auto fff1 = [this](const tbb::blocked_range<size_t>& r) {
			int* p_boundary, * p_band, i1, i = r.begin();
			float* p_t1;
			mystruct* p_base;
			for (p_boundary = boundary + i, p_t1 = t1 + i, p_band = band + i; i != r.end(); ++i, p_boundary++) {
				i1 = *(p_boundary);
				p_base = base + i1;
				float& ui = p_base->u;
				if (ui > c1) {
					ui = c1;
				}
				else if (ui < c2)
					ui = c2;
				p_base->u_for_openmp = ui;
				*(p_t1++) = p_base->u;
				*(p_band++) = i1;
			}
			};
		tbb::parallel_for(tbb::blocked_range<size_t>(0, size_boundary), fff1);

		size_band = size_boundary;

		size_band_openmp = 0;
		auto tt1 = [this]() {
			bool ff = 1;
			for (int i = 0; i < total; i++) {
				ff &= (std::abs(base[i].u - base[i].u_for_openmp) < 1e-5);
			}
			return ff;
			};
		assert(tt1());


		tbb::parallel_invoke([this] {faster_distance_transform_iterate3(q1, q2, band, size_band, size1, size2); }, [this] {faster_distance_transform_inverse_iterate3(q1_for_openmp, q2_for_openmp, band_for_openmp, size_band_openmp, size1_openmp, size2_openmp); });

		/*faster_distance_transform_iterate3(q1, q2, band, size_band, size1, size2);
		faster_distance_transform_inverse_iterate3(q1_for_openmp, q2_for_openmp, band_for_openmp, size_band_openmp, size1_openmp, size2_openmp);*/

		{
			int size_band_origin = size_band;
			auto fff2 = [this, size_band_origin](const tbb::blocked_range<size_t>& r) {
				int i1, i = r.begin();
				int* p_band_for_openmp;
				int* p_band;
				mystruct* p_base;
				for (p_band_for_openmp = band_for_openmp + i, p_band = band + i + size_band_origin; i != r.end(); ++i) {
					i1 = *(p_band_for_openmp++);
					*(p_band++) = i1;
					p_base = base + i1;
					p_base->u = p_base->u_for_openmp;
				}
				};
			tbb::parallel_for(tbb::blocked_range<size_t>(0, size_band_openmp), fff2);
			size_band = size_band_origin + size_band_openmp;
		}
		//{

		//	for (int i = 0; i < size_boundary; i++) {
		//		u[boundary[i]] = t1[i];
		//	}
		//}
		{
			auto fff3 = [this](const tbb::blocked_range<size_t>& r) {
				int i1, i = r.begin();
				float* p_t1 = t1 + i;
				int* p_boundary = boundary + i;
				for (; i != r.end(); ++i, ++p_boundary, ++p_t1) {
					base[*p_boundary].u = *p_t1;
				}
				};
			tbb::parallel_for(tbb::blocked_range<size_t>(0, size_boundary), fff3);
		}


		/*assert(tt1());*/


	}


private:
	//1:big mask=1,c=2
	int* q1;
	int* q1_for_openmp;
	int size1 = 0, size1_openmp = 0;
	const float c1;
	float* mc1;
	//2:low mask=0 c=-2
	int* q2;
	int* q2_for_openmp;
	int size2 = 0, size2_openmp = 0;
	const float c2;
	float* mc2;
	//std::ofstream myfile;
	//bw of band are 0 1 and bw_boundary
	int* band;
	int* band_for_openmp;
	int size_band = 0, size_band_openmp = 0;
	//bw of boundary is 2
	int* boundary;
	float* t1;
	float* t2;
	float* t3;

	//mxArray* p1;
	//mxArray* p2;
	//mxArray* p3;
	struct mystruct* base;
	mxArray* p0;
	//std::vector<float> curvature_term;
	int size_boundary = 0;

	const int dims = 3;

	const int* offset;
	const int total;
	const float  mu, lambda1, lambda2;
	int times;
	const bool record;
};

MyClass::MyClass(read& temp, mxArray* plhs[]) : total(temp.total), offset(temp.offset), base(temp.base), mu(temp.mu), lambda1(temp.lambda1), lambda2(temp.lambda2), c1(temp.c1), c2(temp.c2), times(temp.times), p0(temp.p0), record(temp.record)
{


	q1 = new int[total];
	q2 = new int[total];
	q1_for_openmp = new int[total];
	q2_for_openmp = new int[total];
	band_for_openmp = new int[total];
	boundary = new int[total];
	band = new int[total];
	t1 = new float[total];
	t2 = new float[total];
	t3 = new float[total];
	mc1 = new float[num_image];
	mc2 = new float[num_image];

	init_boundary();



	mexPrintf("mu:%.6f lambda1:%.6f lambda2:%.6f c1:%.6f c2:%.6f times:%d\n", mu, lambda1, lambda2, c1, c2, times);
	/*auto prin = [this](int i1, int i2, int i3) {
		{
			mxArray* temp = mxCreateNumericArray(mxGetNumberOfDimensions(p0), mxGetDimensions(p0), mxDOUBLE_CLASS, mxREAL);
			memcpy(mxGetPr(temp), u, sizeof(float) * mxGetNumberOfElements(p0));
			savemat(temp, (boost::format("C:\\Users\\38316\\Desktop\\to_delete\\temp2\\debug_u%d_%d_%d.mat") % i1 % i2 % i3).str().c_str(), "u");
			mxDestroyArray(temp);
		}
		{
			mxArray* temp = mxCreateNumericArray(mxGetNumberOfDimensions(p0), mxGetDimensions(p0), mxUINT8_CLASS, mxREAL);
			memcpy(mxGetPr(temp), bw, sizeof(mxUint8) * mxGetNumberOfElements(p0));
			savemat(temp, (boost::format("C:\\Users\\38316\\Desktop\\to_delete\\temp2\\debug_bw%d_%d_%d.mat") % i1 % i2 % i3).str().c_str(), "bw");
			mxDestroyArray(temp);
		}
		return true;
	};*/


	int count = -1;
	int i;
	mystruct* p_base;
	for (i = 0, p_base = base; i < total; i++, p_base++) {
		p_base->u_for_openmp = p_base->u;
	}
	mwSize sz[] = { 1,times };
	mxArray* record_array = mxCreateNumericArray(2, sz, mxINT32_CLASS, mxREAL);
	mxInt32* record_array_p = (mxInt32*)mxGetData(record_array);
	auto start = std::chrono::high_resolution_clock::now();
	auto end = start;
	int count_to_display = 0;
	while (times--) {
		count++;
		count_to_display++;
		//printf("%d\n", times);
		if (record) {
			int ss = 0;
			mystruct* base_p = base;
			for (int i = 0; i < total; i++, base_p++)
				ss += (base_p->u) < 0 ? 0 : 1;

			record_array_p[count] = ss;
		}
		if (count_to_display % 20 == 0) {
			end = std::chrono::high_resolution_clock::now();
			int ss = 0;
			mystruct* base_p = base;
			for (int i = 0; i < total; i++, base_p++)
				ss += (base_p->u) < 0 ? 0 : 1;
			mexPrintf("times:%d sum_bw:%d\n", count_to_display, ss);
			auto duration = std::chrono::duration_cast<std::chrono::microseconds>(end - start);

			
			start = end;
			std::cout << "Time taken by program is : " << std::fixed
				<< duration.count();
			std::cout << " microseconds" << std::endl;
		}


		//assert(prin(count, 0, mynum));


		iterate3_2();


		get_mean_with_new_boundary_2_1();



		update_boundary_1();



	}
	iterate3_2();

	{
		mexPrintf("save file\n");
		float* p_p0 = (float*)mxGetData(p0);
		mystruct* p_mystruct;
		int i = 0;
		for (p_mystruct = temp.base, i = 0; i < temp.total; i++, p_mystruct++, p_p0++) {
			*p_p0 = p_mystruct->u;
			delete[] p_mystruct->data;

		}
	}

	delete[] offset;
	delete[]	q1;
	delete[]	q2;
	delete[]	q1_for_openmp;
	delete[]	q2_for_openmp;
	delete[]	band_for_openmp;
	delete[]	boundary;
	delete[]	band;
	delete[]	t1;
	delete[]	t2;
	delete[]	t3;
	delete[] base;
	delete[] mc1;
	delete[] mc2;
	plhs[0] = p0;
	if (record)
		plhs[1] = record_array;




}

MyClass::~MyClass()
{
}

// bw:
// 33333333
// 30000003
// 30222003
// 30212003
// 30222003
// 30000003
// 33333333
// 3:pad
// 0:outside
// 2:boundary
// 1:inside

void mexFunction(int nlhs, mxArray* plhs[], int nrhs, const mxArray* prhs[])


{
	read temp;
	temp.p0 = mxDuplicateArray(prhs[0]);

	getneighbor(temp.p0, temp.total, temp.offset);
	int i;
	mystruct* p_mystruct;
	float* p_f;
	temp.base = new mystruct[temp.total];
	float* u = (float*)mxGetData(temp.p0);

	for (p_mystruct = temp.base, i = 0; i < temp.total; i++, p_mystruct++, u++) {
		p_mystruct->u = *u;
	}

	mxArray* p1 = mxDuplicateArray(prhs[1]);
	float* data = (float*)mxGetData(mxDuplicateArray(p1));
	auto aa = mxGetDimensions(p1);
	int dims = mxGetNumberOfDimensions(p1);
	assert(dims == 4);
	num_image = aa[0];
	//size: 4 * 512* 512* 800
	for (p_mystruct = temp.base, i = 0; i < temp.total; i++, p_mystruct++) {
		p_mystruct->data = new float[num_image];
		for (int i = 0; i < num_image; i++) {
			p_mystruct->data[i] = *data;
			data++;
		}
	}


	mxDestroyArray(p1);
	mxArray* p2 = mxDuplicateArray(prhs[2]);
	float* ricci = (float*)mxGetData(mxDuplicateArray(p2));
	for (p_mystruct = temp.base, i = 0; i < temp.total; i++, p_mystruct++, ricci++) {
		p_mystruct->ricci = *ricci;
	}
	mxDestroyArray(p2);
	mxArray* p3 = mxDuplicateArray(prhs[3]);
	mxUint8* bw = (mxUint8*)mxGetData(mxDuplicateArray(p3));
	for (p_mystruct = temp.base, i = 0; i < temp.total; i++, p_mystruct++, bw++) {
		p_mystruct->bw = *bw;
	}
	mxDestroyArray(p3);
	mxArray* p4 = mxDuplicateArray(prhs[4]);
	const mxDouble* pd = (mxDouble*)mxGetData(p4);
	temp.mu = pd[0];
	temp.lambda1 = pd[1];
	temp.lambda2 = pd[2];
	temp.c1 = pd[3];
	temp.c2 = pd[4];
	temp.times = pd[5];
	temp.record = pd[6];
	mxDestroyArray(p4);



	MyClass fff(temp, plhs);


	return;
}